#include "physics_entity.h"
#include "camera.h"
#include "rigidbody.h"
#include "shape.h"
#include "render.h"

void physics_entity_debug_draw(PhysicsEntity self) {
    RigidBody* body = self.tc->get_rigidbody(self.data);
    Shape* shape = self.tc->get_shape(self.data);
    Transform* transform = self.transformable->get_transform(self.data);

    shape_draw(shape, *transform);
    rigidbody_debug_draw_contacts(body);

    Vector lhs = transform->position;
    Vector rhs = vaddf(lhs, rigidbody_get_velocity(body));
    lhs = camera_world_to_pixel_point(&g_camera, lhs);
    rhs = camera_world_to_pixel_point(&g_camera, rhs);
    SDL_SetRenderDrawColor(g_renderer, 0, 255, 0, 255);
    SDL_RenderDrawLine(g_renderer, lhs.x, lhs.y, rhs.x, rhs.y);

    rhs = camera_world_to_pixel_point(&g_camera, vaddf(transform->position, rigidbody_get_force(body)));
    SDL_SetRenderDrawColor(g_renderer, 0, 255, 255, 255);
    SDL_RenderDrawLine(g_renderer, lhs.x, lhs.y, rhs.x, rhs.y);
}
